2019-10-31  Albert Chu  <chu11@llnl.gov>

	* src/libgenders/Makefile.am: Add make target for
	query_parse.tab.c.

2019-10-30  Albert Chu  <chu11@llnl.gov>

	* src/libgenders/genders_parsing.c: Fix corner case in which lines
	without newlines are assumed invald.

	* tag genders-1-27-1

2019-06-19  Ben Casses <casses1@llnl.gov>

	* merged PR from @sdm900 for faster parsing

	* removed now unused fd.c & fd.h

	* updated version

	* updated copyrights

2018-12-04  Ben Casses <casses1@llnl.gov>

	* catching up on old pulls

	* tag 1-24-1

	* src/nodeattr/nodeattr.c (main): User can now use -X to exclude from -A.

	* META : Update release

2017-03-09  Ben Casses <casses1@llnl.gov>

	* src/nodeattr/: added --compress-hosts and hidden --compress-attrs option.

2015-05-07  Albert Chu  <chu11@llnl.gov>

	* Add contrib for dynamic library support in cfengine 3.3.0 from John
	Westlund (john dot a dot westlund at intel dot com).

	* Add contrib for cfengine genders module from Mark
	Grondona (grondona1 at llnl dot gov).
	
2015-04-29  Albert Chu  <chu11@llnl.gov>

	* Add contrib for dynamic library support in cfengine 2.2.10 from Mark
	Grondona (grondona1 at llnl dot gov).
	
2015-02-12  Albert Chu  <chu11@llnl.gov>

	* NEWS: Update for release.

	* configure.ac; Update library versions appropriately.

	* tagged genders-1-22-1

2015-02-12  Albert Chu  <chu11@llnl.gov>

	* src/extensions/python/genders.py (main): Add getnodename test.

2015-02-12  Adam Bertsch <bertsch2@llnl.gov>

	* src/extensions/python/genders.py (getnodename): Fix error in
	return of value.
	
2014-06-03  Albert Chu  <chu11@llnl.gov>

	* src/testsuite/: Revert unbalanced hostrange nodename tests.  Was
	determined not to be valid.
	
2014-06-02  Albert Chu  <chu11@llnl.gov>

	* src/testsuite/: Adjust tests for unbalanced hostrange nodenames.

	* src/testsuite/: Support tests with hostrange brackets in suffix.

2014-04-11  Albert Chu  <chu11@llnl.gov>

	* genders.spec.in : Default to not building java extensions

	* META : Update release

	* tagged genders-1-21-2

2014-04-11  Albert Chu  <chu11@llnl.gov>

	* NEWS: Update for release.

	* configure.ac; Update library versions appropriately.

	* tagged genders-1-21-1

2014-02-24  Albert Chu  <chu11@llnl.gov>

	* src/testsuite/: Add new tests for unbalanced hostrange
	nodenames.
	
2013-08-02  Albert Chu  <chu11@llnl.gov>

	* src/libcommon/hostlist.c (_parse_single_range): Comment out
	debug messages.
	
2013-08-02  Albert Chu  <chu11@llnl.gov>

	* src/libgenders/genders_parsing.c (_parse_line): Return parse
	error instead of out of memory error in nodenames specified by
	user are incorrectly formatted.
	
2013-08-02  Albert Chu  <chu11@llnl.gov>

	* src/extensions/perl/Genders/Genders.pm.in,
	src/extensions/perl/Libgenders/Libgenders.pm.in: Fix errors in
	genders query documentation.
	
2012-08-27  Albert Chu  <chu11@llnl.gov>

	* Add javadocs to Java extensions.
	
	* Remove parse() routines from c++ and java extensions.  Do not
	apply given API.

	* Fix up java extensions corner cases.
	
2012-08-25  Albert Chu  <chu11@llnl.gov>

	* Support Java JNI extension.
	
2012-08-15  Albert Chu  <chu11@llnl.gov>

	* tagged genders-1-20-1

2012-08-13  Albert Chu  <chu11@llnl.gov>

	* Support --with-non-shortened-hostnames compile option.

2012-08-10  Wil Cooley <wilcooley@gmail.com>

	* src/extensions/python/genders.py (__init__): Fix typo.
	
2012-06-26  Albert Chu  <chu11@llnl.gov>

	* tagged genders-1-19-1
	
2011-10-21  Albert Chu  <chu11@llnl.gov>

	* Update copyright years globally.
	
2011-08-05  Py Watson <watson30@llnl.gov>

	* man/genders_load_data.3: Fix typo.
	
2011-07-12  Albert Chu  <chu11@llnl.gov>

	* configure.ac: Change default install to vendorarch instead of
	sitearch.

	* genders.spec.in: Update for change appropriately.
	
2011-05-09  Albert Chu  <chu11@llnl.gov>

	* tagged genders-1-18-1

2011-05-09  Albert Chu  <chu11@llnl.gov>

	* src/nodeattr/: Support --compress option.

	* src/nodeattr/: Make --expand and --compress output prettier.
	
2011-05-05  Albert Chu  <chu11@llnl.gov>

	* src/nodeattr/: If -A is specified without an output format,
	assume an output format.
	
2011-05-05  Albert Chu  <chu11@llnl.gov>

	* src/libgenders/: Support RAW_VALUES flag.

	* src/testsuite/: Support RAW_VALUES testing.
	
2011-05-04  Albert Chu  <chu11@llnl.gov>

	* src/libgenders/: Add new functions genders_get_flags and
	genders_set_flags.

	* src/testsuite/libgenders/: Support genders_get_flags and
	genders_set_flags tests.
	
2011-05-03  Albert Chu  <chu11@llnl.gov>

	* man/nodeattr.1: Fix typos.

	* src/nodeattr/: Support --expand option.
	
2011-05-02  Albert Chu  <chu11@llnl.gov>

	* src/nodeattr/: Support -A option.
	
2011-04-11  Albert Chu  <chu11@llnl.gov>

	* src/extensions/cplusplus/: throw bad_alloc exception instead of
	genders specific exception on memory allocation error.
	
2011-03-15  Albert Chu  <chu11@llnl.gov>

	* tagged genders-1-17-1

2011-03-15  Albert Chu  <chu11@llnl.gov>

	* src/extensions/cplusplus/gendersplusplus.cpp
	(Genders::getnodename): Fix free bug.

	* src/extensions/cplusplus/gendersplusplus.cpp: Fix RHEL6 compile
	bug.
	
2011-03-15  Albert Chu  <chu11@llnl.gov>

	* configure.ac: Add AC_PROG_CXX check.
	
2011-03-14  Albert Chu  <chu11@llnl.gov>

	* tagged genders-1-16-1
	
2011-03-10  Albert Chu  <chu11@llnl.gov>

	* Support --with-perl-site-arch and --with-perl-vendor-arch
	configure options to support install in Perl site or vendor arch
	directories.
	
2011-03-02  Albert Chu  <chu11@llnl.gov>

	* META, configure.ac: Update for release.

	* tagged genders-1-15-1

2011-03-01  Albert Chu  <chu11@llnl.gov>

	* src/extensions/cplusplus/: Add experimental C++ genders library.

	* src/libgenders/: Add new genders_copy() function.


	* src/libgenders/: Re-architect attrvalslist architecture to
	contain a list of structs instead of a list of lists.

	* genders.spec.in, configure.ac,
	config/ac_cplusplus_extensions.m4: Support optional extensions
	build.
	
2011-03-01  Albert Chu  <chu11@llnl.gov>

	* src/libgenders/genders.c, src/libgenders/genders_parsing.c: Fix
	several potential corruption corner cases related to
	genders_parse() implementation.
	
2011-02-18  Albert Chu  <chu11@llnl.gov>

	* src/libgenders/genders_parsing.c (_insert_node): Fix cleanup
	corner case.
	
2011-02-16  Albert Chu  <chu11@llnl.gov>

	* src/extensions/python/genderssetup.py: Fix build bug.
	
2011-02-08  Albert Chu  <chu11@llnl.gov>
	
	* src/libgenders/: Treat empty string (i.e. "") identically to
	NULL in genders_query and genders_testquery.

	* src/testsuite/libgenders/: Update for new test cases.

2011-02-07  Albert Chu  <chu11@llnl.gov>

	* src/libgenders/: Treat empty string (i.e. "") identically to
	NULL for many circumstances.

	* src/testsuite/libgenders/: Update for new test cases.

2011-01-27  Albert Chu  <chu11@llnl.gov>

	* src/libgenders/genders.c (genders_testattr): Fix corner case.
	
2011-01-21  Albert Chu  <chu11@llnl.gov>

	* src/libgenders/: Fix various parsing corner cases.  In
	particular, deal with empty-string attributes, empty-string
	values, and errant commas.

	* src/testsuite/: Update w/ test cases.
	
2011-01-19  Albert Chu  <chu11@llnl.gov>

	* src/libgenders/genders.h.in: Support C++ linking.

	* src/extensions/python/genderssetup.py.in: Autoconf python lib version number.
	
2010-01-06  Albert Chu  <chu11@llnl.gov>

	Support Python Extensions 

	* Re-architect src/ subdirectory.  Place perl extensions under new
	extensions sub directory.

	* config/ac_perl_destdir.m4: Renamed config/ac_extension_destdir.m4.

	* src/extensions/python/: New
	
	* configure.ac: Update appropriately.

	* genders.spec.in: Update appropriately.

2011-01-04  Albert Chu  <chu11@llnl.gov>

	* src/Libgenders/Libgenders.pm.in: Fix some documentation.

2010-12-22  Albert Chu  <chu11@llnl.gov>

	* src/libgenders/genders_parsing.c (_attr_node_processsing): Fix
	corner case in logic leading to errors when running
	genders_parse().
	
2010-08-19  Albert Chu  <chu11@llnl.gov>

	* genders.spec.in: Update for build on RHEL6.
	
2010-03-24  Albert Chu  <chu11@llnl.gov>

	* META, configure.ac: Update for release.

	* tagged genders-1-14-1
	
2010-03-24  Albert Chu  <chu11@llnl.gov>

	* src/libgenders/: Support plus signs in genders queries.

	* src/testsuite/libgenders/: Support plus sign tests.
	
2010-02-01  Albert Chu  <chu11@llnl.gov>

	* Update copyright globally.
	
2009-10-09  Albert Chu  <chu11@llnl.gov>

	* genders.spec.in: Add appropriate build requires.
	
	* tagged genders-1-13-2

2009-08-12  Albert Chu  <chu11@llnl.gov>

	* src/Genders/Makefile.am: Revert portability fixes.

	* src/Libgenders/Makefile.am, genders.spec.in: Fix portability
	issues.

2009-08-11  Albert Chu  <chu11@llnl.gov>

	* src/Genders/Makefile.am: Fix portability bug.
	
2009-06-02  Albert Chu  <chu11@llnl.gov>

	* man/genders_query.3, man/libgenders.3: Update for const
	parameter.

	* man/genders_query.3: Fix example.

	* src/libgenders/genders.h.in: Add extra instructions/comments.
	
	* man/genders_testquery.3: New file.

	* man/libgenders.3: Add genders_testquery().

	* src/nodeattr/nodeattr.c (main): Rework command line option error
	checking to be more logical and easier to understand.

	* src/nodeattr/nodeattr.c, man/nodeattr.1: Support new -Q option
	in nodeattr.

	* configure.ac: Update library versions.  Update for release.

	* tagged genders-1-13-1

2009-06-02  Albert Chu  <chu11@llnl.gov>

	* src/Genders/Genders.pm.in, src/Libgenders/Libgenders.pm.in,
	src/Libgenders/Libgenders.xs, src/libgenders/genders.h.in,
	src/libgenders/genders_query.y: Add support for new function
	genders_testquery().

	* src/testsuite/libgenders/: Add tests for genders_testquery().

2009-06-01  Albert Chu  <chu11@llnl.gov>

	* src/libgenders/genders.h.in, src/libgenders/genders_query.y
	(_parse_query, genders_query): Make query parameter a const.

	* src/libgenders/genders.h.in: Add additonal comments.
	
2009-05-20  Albert Chu  <chu11@llnl.gov>

	* src/libgenders/genders_parsing.c (_parse_line): Remove
	unnecessary error check that is now handled through new parsing
	architecture.

	* src/libgenders/genders_parsing.c (_insert_ptr): Removed function.

	* src/libgenders/genders_parsing.c (_parse_line): Adjust code
	appropriately given function removal.

	* src/libgenders/genders_parsing.c
	(_duplicate_attr_in_node_check): Renamed _attr_node_processsing
	due to functional changes.

	* src/libgenders/genders_parsing.c (_attr_node_processsing): Use
	hash_find instead of _genders_find_attrval() to avoid a few extra
	list iterations.

	* src/libgenders/genders.c: node_index and attr_index cannot be
	NULL after genders_load_data(), so check numnodes and numattrs
	variables instead.
	
	* tagged genders-1-12-1

2009-05-19  Albert Chu  <chu11@llnl.gov>

	* src/libgenders/genders.c (genders_isattrval): Improve
	performance by using specific index.
	
	* src/libgenders/genders_parsing.c, src/libgenders/genders_api.h,
	src/libgenders/genders_util.c: Rework parsing code and searching
	code so that the lists stored in each gender's node's attrlist is
	index via a hash.  Utilize the index during search functions.
	Should greatly improve performance of database parsing/loading
	time and many libgenders functions.

2009-05-18  Albert Chu  <chu11@llnl.gov>

	* src/libcommon/hash.h, src/libcommon/hash.c (hash_remove_if): New
	function.

	* src/libgenders/genders_util.h, src/libgenders/genders_util.c
	(_genders_list_is_node): Removed function.

	* src/libgenders/genders_util.h, src/libgenders/genders_util.c
	(_genders_rehash): New function.

	* src/libgenders/genders_parsing.h,
	src/libgenders/genders_parsing.c (_genders_index_nodes,
	_genders_index_attrs): Removed functions.

	* src/libgenders/genders.c, src/libgenders/genders_parsing.c,
	src/libgenders/genders_api.h: Rework parsing code so that
	node_index and attr_index are built as the database is parsed,
	instead of at the very end.  Utilize the indexes during parsing.
	Should greatly improve performance of database parsing/loading
	time.
	
2009-05-15  Albert Chu  <chu11@llnl.gov>

	* Add comments for clarification.
	
2009-04-06  Albert Chu  <chu11@llnl.gov>
	
	* src/libgenders/genders_parsing.c (_parse_line): Revert check for
	equal sign in value, allow it.

	* src/testsuite/libgenders/testdatabases/genders.equal_sign_in_value: New file.

	* testsuite/libgenders/genders_test_database.c: Add test to check
	for supported equal sign in value.  Remove test for equal sign in value as error.
	
2009-04-03  Albert Chu  <chu11@llnl.gov>

	* src/libgenders/genders_parsing.c (_parse_line): Check for
	equal-signs in values.

	* src/testsuite/libgenders/testdatabases/genders.parse_error_equal_sign_in_value_1,
	src/testsuite/libgenders/testdatabases/genders.parse_error_equal_sign_in_value_2: New files.

	* testsuite/libgenders/genders_test_database.c: Add tests for
	equal-sign parse errors.
	
2009-02-19  Albert Chu  <chu11@llnl.gov>

	* META: Update for release.

	* tagged genders-1-11-4

2009-02-18  Albert Chu  <chu11@llnl.gov>

	* config/ac_perl_extensions.m4: New file.
	
	* configure.ac, src/Libgenders/Makefile.am,
	src/Genders/Makefile.am: Support capability to not build perl
	extensions libs.

2009-02-18  Albert Chu  <chu11@llnl.gov>

	* genders.spec.in: Revert sles10 fix from 2008-10-28, issue is
	something else in Suse.

2008-10-28  Albert Chu  <chu11@llnl.gov>

	* genders.spec.in: Fix sles10 rpmbuild issue.
	
2008-09-02  Albert Chu  <chu11@llnl.gov>

	* genders.spec.in: Change build requires from byacc to bison for
	portability.

	* META: Update for release.

	* tagged genders-1-11-3

2008-07-22  Albert Chu  <chu11@llnl.gov>
	
	* META: Update for release.

	* tagged genders-1-11-2

2008-07-21  Albert Chu  <chu11@llnl.gov>

	* src/libgenders/genders_query.y: Remove compiler warning.

	* src/libgenders/Makefile.am,
	src/libgenders/genders_query_parsing.l: Fix porting issues for
	Solaris.

	* configure.ac: Support --with-force-yacc build option.
	
2008-07-11  Albert Chu  <chu11@llnl.gov>
	
	* configure.ac: Update for release.

	* NEWS: Update for release.

	* META: Update for release.

	* tagged genders-1-11-1

2008-07-11  Albert Chu  <chu11@llnl.gov>

	* src/testsuite/libgenders/testdatabases/genders.bugzilla414_1,
	src/testsuite/libgenders/testdatabases/genders.bugzilla414_2,
	src/testsuite/libgenders/testdatabases/genders.bugzilla414_3,
	src/testsuite/libgenders/testdatabases/genders.bugzilla414_4,
	src/testsuite/libgenders/testdatabases/genders.bugzilla414_5: New files.

	* src/testsuite/libgenders/: Add tests for bugzilla 414 (LLNL
	CHAOS bug).

	* src/libcommon/hostlist.c: Updated to new version.  Fixes
	bugzilla 414.
	
2008-06-28  Albert Chu  <chu11@llnl.gov>

	* configure.ac: Update for release.

	* NEWS: Update for release.

	* tagged genders-1-10-1

2008-06-27  Albert Chu  <chu11@llnl.gov>

	* configure.ac: Update for release.

	* tagged genders-1-9-2

2008-04-11  Albert Chu  <chu11@llnl.gov>

	* src/nodeattr/nodeattr.c (usage): Add missing -U option to usage.
	
2008-04-03  Albert Chu  <chu11@llnl.gov>

	* configure.ac: Update for release.

	* NEWS: Update for release.

	* tagged genders-1-9-1

2008-03-28  Albert Chu  <chu11@llnl.gov>

	* man/: Fix nroff syntax errors.

	* update copyrights in a lot of places
	
2008-03-07  Albert Chu  <chu11@llnl.gov>

	* src/libgenders/genders_query.y (_parse_query): Fix potential
	corner cases.
	
2008-03-04  Albert Chu  <chu11@llnl.gov>

	* src/nodeattr/nodeattr.c: Support new -V and -U options.  Add
	error checks for all list creation calls.

	* man/nodeattr.1: Update documentation for -V and -U options.
	
2008-02-14  Albert Chu  <chu11@llnl.gov>

	* man/nodeattr.1: Add some text to highlight -q option.
	
2008-01-29  Albert Chu  <chu11@llnl.gov>

	* src/libcommon/hostlist.h, src/libcommon/hostlist.c: Update to
	new libs.
	
2008-01-28  Albert Chu  <chu11@llnl.gov>

	* src/Libgenders/Libgenders.xs (genders_getattr): Fix corner case.

	* src/libgenders/genders_query.y (_genders_makenode, _calc_attrval_nodes,
	_calc_complement): Fix potential mem-leak.
	
2007-12-21  Albert Chu  <chu11@llnl.gov>

	* configure.ac: Update for release.

	* NEWS: Update for release.

	* tagged genders-1-8-1

2007-12-19  Albert Chu  <chu11@llnl.gov>

	* src/libgenders: Support empty genders files as an acceptable
	input (i.e. not a parse error).

	* src/testsuites: Adjust old testsuite and add new tests
	appropriately.
	
2007-10-16  Albert Chu  <chu11@llnl.gov>

        * DISCLAIMER.UC: New file.

        * DISCALIMER: Updated with new disclaimer.

        * Fixed copyright and FSF address globally.

	* Makefile.am, genders.spec.in: Add DISCLAIMER.UC.

2007-10-16  Jeff Cunningham <cunningham24@llnl.gov>

	* contrib/php/genders.c (PHP_FUNCTION): Reduce excessive error
	output.
	
2007-10-03  Albert Chu  <chu11@llnl.gov>

	* contrib/: Add new contrib directory.

	* Makefile.am, configure.ac: Update for new contrib directory.

	* contrib/php/: Add PHP Bindings support from Jeff Cunningham
	(cunningham24 at llnl dot gov).
	
2007-09-18  Albert Chu  <chu11@llnl.gov>

	* configure.ac: Update for release.

	* tagged genders-1-7-1
	
2007-09-12  Albert Chu  <chu11@llnl.gov>

	* src/nodeattr/nodeattr.c (list_nodes): Fix -X usage corner case.

	* src/nodeattr/nodeattr.c (_diff): Fix error message typos.
	
	* META, NEWS: Update for release.

2007-09-11  Albert Chu  <chu11@llnl.gov>

	* META: Update for release.

	* tagged genders-1-6-2
	
2007-09-05  Albert Chu  <chu11@llnl.gov>

	* Fix FSF address throughout.
	
2007-07-26  Albert Chu  <chu11@llnl.gov>

	* genders.spec.in: Change "Prereq" perl requirement to "Requires".
	Add "byacc" and "flex" build requirements.

2007-04-21  Albert Chu  <chu11@llnl.gov>

	* config/Make-rpm.mk: Remove localism.

	* genders.spec.in: Fix build.

	* Makefile.am: Add genders.spec to dist.  Remove localism.
	
2007-01-10  Albert Chu  <chu11@llnl.gov>

	* src/libgenders/genders_query_parse.l: Added backslash and
	forward slash.

	* src/testsuite/libgenders/genders_test_query_tests.c,
	src/testsuite/libgenders/testdatabases/genders.query_special_chars:
	Added slash parsing tests.

	* tagged genders-1-6-1

2007-01-09  Albert Chu  <chu11@llnl.gov>

	* src/libgenders/genders_query_parse.l: Added colons.

	* src/testsuite/libgenders/genders_test_query_tests.c,
	src/testsuite/libgenders/testdatabases/genders.query_special_chars:
	Added colon parsing tests.

2007-01-09  Albert Chu  <chu11@llnl.gov>

        * tagged pre_aix_patches.
	
	Apply AIX port patches by Py Watson (watson30 at llnl dot gov)

	* configure.ac, src/Genders/Makefile.am: Determine and use correct
	extension for Perl's section-3 man pages.

	* src/Genders/Makefile.am: Correct calculation of where perl
	expects to put site architecture specific files.  As part of this,
	make the perl install directory consistent with what is used for
	Libgenders.  Use $PERL instead of perl, so that correct perl
	version is used.

	* src/Libgenders/Makefile.am: Override the install location for
	the Libgenders man page, since the perl default is not based off
	of the install prefix.

	* src/Libgenders/Makefile.PL, src/Libgenders/Makefile.am: On AIX,
	set the compiled-in library path for dynamic libraries to the path
	where the C library is installed plus the default library
	path. Otherwise, the library path contains an entry for the
	genders library in the source directory.

	* Makefile.am: Replace --with-perl-install-destdir with
	--with-perl-destdir.
	
        * tagged post_aix_patches.

2007-01-05  Albert Chu  <chu11@llnl.gov>

	* src/testsuite/libgenders/genders_test_corner_case.c,
	src/testsuite/libgenders/genders_test_functionality.c: Fix Solaris
	port issue.
	
2006-12-28  Albert Chu  <chu11@llnl.gov>

	* src/testsuite/libgenders/genders_test_corner_case.c,
	src/testsuite/libgenders/genders_test_functionality.c: Check for
	paths.h and add Solaris build fix for _PATH_DEVNULL define.

	* configure.ac: Search for pod2man in /usr/perl5/bin for Solaris.
	
2006-12-18  Albert Chu  <chu11@llnl.gov>

	* configure.ac, src/libgenders/genders_query.y: Check for paths.h
	and add Solaris build fix for _PATH_DEVNULL define.

	* src/libgenders/genders_parsing.c (strsep): New function for
	those machines that don't include it.
	
2006-11-28  Albert Chu  <chu11@llnl.gov>

	* man/libgenders.3: Fix typo found by Py Watson (watson30 at llnl
	dot gov).
	
2006-11-14  Albert Chu  <chu11@llnl.gov>

	* src/libgenders/genders_parsing.c (_parse_line): Remove
	unnecessary code.
	
2006-09-27  Albert Chu  <chu11@llnl.gov>

	* src/nodeattr.c (diff_genders, _diff): Alter way that diff output
	is output and generated.

	* man/nodeattr.1: Update wording appropriately.

	* tagged genders-1-5-2
	
2006-09-26  Albert Chu  <chu11@llnl.gov>

	* man/nodeattr.1: Apply backtick manpage fixes from Py Watson
	(watson30 at llnl dot gov).

	* tagged genders-1-5-1

2006-09-26  Albert Chu  <chu11@llnl.gov>

	* man/nodeattr.1, src/nodeattr/nodeattr.c (main, list_nodes):
	Support new -X option.
	
2006-08-28  Albert Chu  <chu11@llnl.gov>

	* genders.spec.in: Modification for possible Suse corner case.
	
2006-07-30  Albert Chu  <chu11@llnl.gov>

	* src/Libgenders/Libgenders.pm.in, src/Genders/Genders.pm.in: Fix
	description of genders_query functions.

	* src/Libgenders/Libgenders.xs (genders_query): Default query to
	NULL if one is not specified.
	
2006-07-17  Albert Chu  <chu11@llnl.gov>

	Changes to make perl extensions build correctly on FC5.

	* config/ac_perl_install_destdir.m4: Removed file.

	* config/ac_perl_destdir.m4: New file.

	* configure.ac: Adjust to use new macro.

	* genders.spec.in: Adjust to use new configure option.
	
	* src/Libgenders/Makefile.am: Adjust makemaker flags
	appropriately.
	
2006-06-19  Albert Chu  <chu11@llnl.gov>

	* src/libcommon: New directory of common files.

	* src/nodeattr, src/libgenders: Adjust Makefiles and remove appropriate files.

	* src/libcommon/hostlist.c: Update to latest library.
	
2006-06-16  Albert Chu  <chu11@llnl.gov>

	* src/libgenders/genders.h.in: Fix comment typo.
	
2006-06-13  Albert Chu  <chu11@llnl.gov>

	* src/libgenders/genders_parsing.c
	(_duplicate_attr_in_node_check): Output duplicate attribute in
	error output.
	
2006-03-27  Albert Chu  <chu11@llnl.gov>

	* configure.ac, src/testsuite/libgenders/Makefile.am,
	src/testsuite/libgenders/testdatabases/Makefile.am: Fixes so 'make
	dist' includes test databases files.
	
2006-03-27  Albert Chu  <chu11@llnl.gov>

	Apply AIX patches from Py Watson (watson30 at llnl dot gov)

	* src/testsuite/libgenders/genders_test.c: Fix getopt.h
	portability bug.

	* src/testsuite/libgenders/genders_test_corner_case.c,
	src/testsuite/libgenders/genders_test_functionality.c: Fix stderr
	re-routing to /dev/null bug.
	
2006-03-24  Albert Chu  <chu11@llnl.gov>

	* configure.ac: Remove AC_FUNC_MALLOC check for portability to
	AIX (from Py Watson, watson30 at llnl dot gov).
	
2005-09-02  Albert Chu  <chu11@llnl.gov>

	* src/testsuite/libgenders/genders_test_corner_case.c
	(_genders_list_clear_corner_case,
	_genders_list_destroy_corner_case): Fix compiler warnings.

	* src/nodeattr/nodeattr.c, man/nodeattr.1: Added support for -d
	option.
	
2005-08-18  Albert Chu  <chu11@llnl.gov>

	* tagged genders-1-4-1
	
2005-07-21  Albert Chu  <chu11@llnl.gov>

	* man/nodeattr.1: Fixed EXAMPLES.
	
2005-07-18  Albert Chu  <chu11@llnl.gov>

	* config/ac_genders_file.m4: Cleaned up.
	
2005-05-13  Albert Chu  <chu11@llnl.gov>

	* src/Genders/Makefile.am: Cleanup and fix build.

	* src/Genders/Makefile.PL: Removed file.

	* configure.ac: Add search for pod2man.

	* tagged genders-1-4-0-pre1
	
2005-05-10  Albert Chu  <chu11@llnl.gov>

	* configure.ac: Updated library versions.

	* src/libgenders/genders_parsing.c (_parse_line): Fix regression bug.
	
2005-05-07  Albert Chu  <chu11@llnl.gov>

	* Various code cleanup and header file re-organization.

2005-04-22  Albert Chu  <chu11@llnl.gov>
	 
        * Various code, autoconf, and makefile cleanup.
	
2005-01-25  Albert Chu  <chu11@llnl.gov>

	* src/nodeattr/nodeattr.c (_gend_error_exit): Output info on
	--parse-check option on parse errors.

	* src/nodeattr/nodeattr.c (main): Fix logic errors when calling
	genders_parse().
	
2005-01-18  Albert Chu  <chu11@llnl.gov>

	* src/libgenders/hash.h, src/libgenders/hash.c: Updated libraries.

	* src/libgenders/hash.c (hash_node_alloc, hash_node_free),
	src/libgenders/list.c (list_alloc_aux, list_free_aux): Modify to
	remove buffering so no mem-leaks occur in libgenders.
	
2005-01-10  Albert Chu  <chu11@llnl.gov>

	* src/libgenders/hostlist.h, src/libgenders/hostlist.c,
	src/nodeattr/hostlist.h, src/nodeattr/hostlist.c: Updated
	libraries.

	* genders.spec.in: Another attempt to fix multilib.
	
2005-01-08  Albert Chu  <chu11@llnl.gov>

	* src/Libgenders/Makefile.am, src/Genders/Makefile.am: Cleanup.

	* genders.spec.in: Fix a Perl Extensions packaging problem for
	multilib systems.

	* src/libgenders/Makefile.am, configure.ac: Move versioning info
	into configure.ac.

	* configure.ac: Added Perl versioning.

	* src/Libgenders/Libgenders.pm: Renamed to Libgenders.pm.in and
	added versioning.

	* src/Genders/Genders.pm: Renamed to Genders.pm.in and added
	versioning.
	
2004-12-31  Albert Chu  <chu11@llnl.gov>

	* src/libgenders/genders_query_parse.l: Be able to parse '&', '|',
	and '-' characters in the important cases.

	* src/libgenders/genders_query_parse.l,
	src/libgenders/genders_query.y: Modify union, intersection, and
	difference symbols to be '||', '&&', and '--' respectively.

	* src/testsuite/libgenders/testdatabases/genders.query_special_chars:
	New file.
	
	* src/testsuite/libgenders/genders_test_query_tests.c: Update
	tests appropriately and add special char tests.

	* src/nodeattr/nodeattr.c (main, list_nodes, usage): Add query
	support to nodeattr.
	
	* man/nodeattr.1: Updated for new query feature.
	
2004-12-30  Albert Chu  <chu11@llnl.gov>

	* src/testsuite/libgenders/genders_test_query_tests.h,
	src/testsuite/libgenders/genders_test_query_tests.c,
	src/testsuite/libgenders/testdatabases/genders.query_1,
	src/testsuite/libgenders/testdatabases/genders.query_1_comma,
	src/testsuite/libgenders/testdatabases/genders.query_1_hostrange,
	src/testsuite/libgenders/testdatabases/genders.query_2,
	src/testsuite/libgenders/testdatabases/genders.query_2_comma,
	src/testsuite/libgenders/testdatabases/genders.query_2_hostrange:
	New files.

	* src/testsuite/libgenders/genders_test.c,
	src/testsuite/libgenders/genders_test_corner_case.h,
	src/testsuite/libgenders/genders_test_corner_case_tests.c,
	src/testsuite/libgenders/genders_test_corner_case.c,
	src/testsuite/libgenders/genders_test_functionality.h,
	src/testsuite/libgenders/genders_test_functionality.c: Added
	genders_query corner case tests, genders_index_attrvals
	functionality tests, and gendes_query functionality tests.

	* src/libgenders/genders_query.y (genders_query): Fix segfault
	corner case, errnum return code corner case, and input parameter
	check errors.

	* src/libgenders/genders.c (genders_index_attrvals): Fix input
	corner case.

	* src/libgenders/genders_query_parse.l: Be able to parse '%'
	character.

	* src/libgenders/genders_query.y (genders_set_complement_flag):
	Fix bug which to allow double-negation.

	* man/genders_testattr.3: Fix cut and paste typo.

	* man/genders_index_attrvals.3: Add GENDERS_ERR_NOTFOUND error
	number.

2004-12-29  Albert Chu  <chu11@llnl.gov>

	Fix various bugs based on testsuite results

	* src/testsuite/Makefile.am, src/testsuite/libgenders/*,
	src/testsuite/libgenders/testdatabases/*: New libgenders testsuite
	added.

	* configure.ac, src/Makefile.am: Made appropriate changes for new
	testsuite.

	* src/libgenders/genders.c (_initialize_handle,
	genders_load_data): Fix attrval_buflist initialization corner case
	that can cause segfaults.

	* src/libgenders/genders.c (genders_load_data): Fix a second segfault
	corner case.

	* src/libgenders/genders.c (genders_load_data),
	src/libgenders/genders_parsing.c (_open_and_parse): Move no parsed
	node check from genders_load_data to _open_and_parse.

	* src/libgenders/genders_parsing.c (_nodename_shortened_check): New function.

	* src/libgenders/genders_parsing.c (_nodename_check): Use new
	_nodename_shortened_check function.
	
	* src/libgenders/genders_parsing.c (_open_and_parse, _parse_line):
	Fix parse error count corner case.

	* src/libgenders/genders.c (genders_getnodename,
	genders_testattr): Fix returned errnum inconsistency compared to
	other genders functions.

	* src/libgenders/genders.c (genders_set_errnum): Allow user to set
	errnum to anything.

	* src/libgenders/genders_parsing.c (_open_and_parse): Fix return
	value bug.

	* src/libgenders/genders_parsing.c (_parse_line): Fix parse error
	corner case.  Fix maxvallen calculation corner case.

	* src/libgenders/genders.c (genders_testattr): Fix val return bug
	when no value exists.

	* src/libgenders/genders_parsing.c (_insert_attr, _parse_line):
	Fix numattrs counting bug.

	* Makefile.am: Fix destdir for distcheck.
	
2004-12-22  Albert Chu  <chu11@llnl.gov>

	* tagged pre_genders_1_4_code_cleanup

	* Major libgenders code cleanup including new files and various
	new functions.  Minor bug fixes throughout.
	
2004-12-18  Albert Chu  <chu11@llnl.gov>

	* genders.spec.in, configure.ac, src/Libgenders/Makefile.am,
	src/Genders/Makefile.am: Fix make install corner case.
	
2004-12-14  Albert Chu  <chu11@llnl.gov>

	* genders.spec.in, src/Genders/Makefile.am,
	src/Libgenders/Makefile.am: Fix 64bit build issue.
	
2004-11-16  Albert Chu  <chu11@llnl.gov>

	* genders.spec.in: Remove copyright, add License.
	
2004-11-13  Albert Chu  <chu11@llnl.gov>

	* README: Updated with better descriptions.

	* TUTORIAL: Fixed wording in a few places.

	* genders.spec.in: Updated description.

	* src/libgenders/genders_query.y (_calc_complement, _calc_query):
	Move destroying of hostlist from _calc_complement to _calc_query.
	
2004-11-10  Albert Chu  <chu11@llnl.gov>

	* src/libgenders/genders_query.y (_calc_query): Handle NULL query
	special by getting all genders nodes.

	* man/genders_query.y: Note special case of NULL query.

	* src/libgenders/genders_query.y, src/libgenders/genders_parse.l:
	Add parsing for tilde ('~') token for set complements.

	* src/libgenders/genders_query.y (_calc_query): Handle complement
	calculation.

	* src/libgenders/genders_query.y (genders_set_complement_flag):
	New function.
	
	* src/libgenders/genders_query.y (_calc_attrval, _calc_union,
	_calc_intersection, _calc_difference, _calc_complement): New
	functions to clean up code.

	* src/libgenders/genders_query.y: Call only hostlist_uniq in
	situations where calling both it and hostlist_sort.

2004-11-06  Albert Chu  <chu11@llnl.gov>

	* src/libgenders/genders_query.y (_calc_query): Modified to return
	0 nodes with a invalid attribute rather than an error.

	* src/libgenders/genders.c, src/libgenders/genders.h.in: Remove
	GENDERS_QUERYINPUT definition and error message.

	* man/genders_query.y: Removed GENDERS_ERR_QUERYINPUT error
	condition.  Cleaned up some english.

	* src/Libgenders/Libgenders.xs: Removed GENDERS_ERR_QUERYINPUT.
	
2004-11-04  Albert Chu  <chu11@llnl.gov>

	* src/libgenders/genders.c, src/libgenders/genders_query.y,
	src/libgenders/genders_common.h: Various minor code cleanup.

	* man/genders_index.3, man/gender_index_nodes.3,
	man/genders_index_attrs.3: Remove unnecessary manpages.

	* man/Makefile.am: Remove unnecessary manpages.

	* man/genders_query.3: Fixed typo.
	
2004-10-28  Albert Chu  <chu11@llnl.gov>

	* genders.spec.in: Additional port fixes.
	
2004-10-26  Albert Chu  <chu11@llnl.gov>

	* genders.spec.in: Minor fix for possibly non gzipped
	manpages. Updated for portable builds.

	* Makefile.am: Additional extra dist.

	* config/Make-rpm.mk: Updated Make-rpm.mk script for portable builds.
	
2004-10-07  Albert Chu  <chu11@llnl.gov>

	Removed genders_index_nodes and genders_index_attrs API functions.
	By default, genders will always hash nodes and attributes.

	* src/libgenders/genders.h.in, src/libgenders/genders.c:
	(genders_index_nodes, genders_index_attrs): Removed functions.

	* src/libgenders/genders.c (genders_handle_create): Create
	node_index and attr_index.

	* src/libgenders/genders.c (_index_nodes, _index_attrs): New
	functions.

	* src/libgenders/genders.c (genders_load_data): Call _index_nodes
	and _index_attrs to setup hashes.  Cleanup appropriately.

	* src/libgenders/genders.c (genders_getnodes, genders_getattr,
	genders_testattr, genders_testattrval, genders_isnoe,
	genders_isattr): Use node and attr indexes automatically.
	
	* src/Libgenders/Libgenders.xs (genders_index_nodes,
	genders_index_attrs): Removed functions.

	* src/Libgenders/Libgenders.pm: Removed references to
	genders_index_nodes and genders_index_attrs in docs.

	* src/Genders/Genders.pm (genders_index_nodes,
	genders_index_attrs): Removed functions and references to them the
	documentation.

	* man/libgenders.3: Removed genders_index_nodes and
	genders_index_attrs.

	* man/Makefile.am: Removed genders_index.3, genders_index_nodes.3,
	and genders_index_attrs.3.

	* man/genders_index_attrvals.3: New file.
	
2004-09-10  Albert Chu  <chu11@llnl.gov>

	* man/nodeattr.1: Re-word description of -k option.

	* src/nodeattr/nodeattr.c: Change --check option to --parse-check.

	* src/nodeattr/nodeattr.c (usage): Output long option for -k if
	long options are available.

	* src/nodeattr/nodeattr.c (list_nodes): Added hostlist_sort() call
	to ensure nodes are sorted in order before output.

	* src/libgenders/genders.c (_parse_line): Fixed english typo.

	* src/libgenders/genders_query.y: Minor code style cleanup.

	* src/libgenders/genders_common.h, src/libgenders/genders.c
	(genders_handle_destroy, genders_load_data,
	genders_index_attrvals): Fix corner case involving the indexing of
	substituted attribute values.

	* src/libgenders/genders.c (genders_index_attrvals): Fix typos in
	comments.
	
2004-06-11  Albert Chu  <chu11@llnl.gov>

	* src/libgenders/Makefile.am, src/Libgenders/Makefile.am,
	src/Genders/Makefile.am: Added distcheck fixes and workarounds.
	
2004-06-10  Albert Chu  <chu11@llnl.gov>

	* src/libgenders/genders.h.in, src/libgenders/genders_query.y,
	src/Libgenders/Libgenders.xs, man/genders_query.3 (genders_query):
	Re-arranged function parameters to be consistent with rest of
	genders API.

	* man/libgenders.3: Added genders_query.

	* src/libgenders/genders_parse.l, src/libgenders/genders_query.y,
	man/genders_query.3, src/Libgenders/Libgenders.pm,
	src/Genders/Genders.pm: Modified parse tokens so that union is '|'
	and intersection is '&'.
	
2004-06-09  Albert Chu  <chu11@llnl.gov>

	* src/libgenders/genders.h.in: Add new SYNTAX and QUERYINPUT error
	codes.

	* src/libgenders/genders_query.y, src/libgenders/genders_parse.l:
	Support attr=val in queries.  Update to use new error codes.

	* src/Libgenders/Makefile.am: Fix for genders_query.

	* man/Makefile.am: Added indexing manpages and genders_query manpage.

	* man/genders_query.3: New file.

	* src/Libgenders/Libgenders.pm, src/Libgenders/Libgenders.xs:
	Added genders_query and new error codes.

	* src/Genders/Genders.pm: Added genders_query.	
	
2004-06-08  Albert Chu  <chu11@llnl.gov>

	* src/libgenders/Makefile.am, src/libgenders/genders_query.y,
	src/libgenders/genders_common.h, src/libgenders/genders.c: Various
	code/make cleanup.
	
2004-06-07  Albert Chu  <chu11@llnl.gov>

	* src/libgenders/Makefile.am, src/Libgenders/Makefile.am,
	src/Genders/Makefile.am: Minor fixes to fix distcheck.
	
2004-06-07  Albert Chu  <chu11@llnl.gov>

	Added genders_query API function

	* src/libgenders/genders.h.in (genders_query): New function.

	* src/libgenders/genders_common.h,
	src/libgenders/genders_common.c, src/libgenders/genders_query.l,
	src/libgenders/genders_query.y: New files.

	* src/libgenders/genders.c: Split off number of declarations and
	functions into genders_common files.

	* src/libgenders/Makefile.am: Updated to include new files.

	* configure.ac: Added yacc and lex check.

2004-05-19  Albert Chu  <chu11@llnl.gov>

	* Makefile.am, compat/Makefile.am, src/libgenders/Makefile.am,
	src/Libgenders/Makefile.am, src/Genders/Makefile.am,
	man/Makefile.am, man/compat/Makefile.am: Fix dist files.

	* src/nodeattr/Makefile.am, src/libgenders/Makefile.am: Makefile cleanup.
	
2004-05-04  Albert Chu  <chu11@llnl.gov>

	* src/Libgenders/Libgenders.xs, src/Libgenders/Libgenders.pm:
	Added indexing functions.

	* src/Genders/Genders.pm: Added indexing functions.
	
2004-05-03  Albert Chu  <chu11@llnl.gov>

	* src/libgenders/genders.c (genders_getnodes): Fixed segfaulting corner case.

	* Added indexing manpages.
	
2004-04-28  Albert Chu  <chu11@llnl.gov>

	* Added attribute indexing.

	* New genders_index_nodes, genders_index_attrs, and
	genders_inde_attrvals functions with indexing support in genders.
	
2004-04-27  Albert Chu  <chu11@llnl.gov>

	* genders.spec.in: Use %configure macro.

	* Localize all symbols that shouldn't be global.

	* Reworked and cleaned up node indexing code.

2004-04-26  Albert Chu  <chu11@llnl.gov>

	* Fixed build issues with Libgenders.

	* Removed MAXHOSTNAMELEN buffer and replaced with pointer and
	malloced buffer.

	* Removed pthread linking.
	
2004-04-22  Albert Chu  <chu11@llnl.gov>

	* src/libgenders/genders.c (genders_load_data): Fixed corner case.
	
2004-04-20  Albert Chu  <chu11@llnl.gov>

	* src/libgenders/genders.c (_parse_line): Made parse error output
	string more informative.

2004-04-16  Albert Chu  <chu11@llnl.gov>

	* src/libgenders/genders.c: Complete initial integration of node
	index hash table.
	
2004-04-14  Albert Chu  <chu11@llnl.gov>

	* src/libgenders/hostlist.h, src/libgenders/hostlist.c: Updated to
	latest copies.

	* src/libgenders/hash.h, src/libgenders/hash.c,
	src/libgenders/thread.h, src/libgenders/thread.c: New files.

	* man/libgenders.3: Fixed several english issues.

	* TUTORIAL: Fixed major mistakes and added more information.

	* src/libgenders/genders.c: Removed maximum attribute and value
	length limits.  Began structure implementation for node index hash
	table.
	
2004-03-09  Albert Chu  <chu11@llnl.gov>

	* src/libgenders/genders.c (_get_val, _duplicate_attr_check):
	Removed unused variables.

	* src/libgenders/genders.c (genders_parse): Output more appropriate
	message when no list successfully parsed.

	* src/libgenders/genders.c (_parse_line): Fix output bug when very
	long attrs or vals found.

	* config/ac_debug.m4: New file.

	* configure.ac: Added --enable-debug option.
	
2004-03-05  Albert Chu  <chu11@llnl.gov>

	* man/libgenders.3: Fixed typo found by Py Watson (watson30@llnl.gov).
	
2004-02-11  Albert Chu  <chu11@llnl.gov>

	* src/libgenders/Makefile.am: Compile with _REENTRANT.

	* tagged genders-1-3-1
	
2004-02-09  Mark Grondona <mgrondona@llnl.gov>

	* compat/hostlist.pl (expand): Properly handle multiple quadrics
	style hostlists separated by the comma character.

2004-02-03  Albert Chu  <chu11@llnl.gov>

	* src/libgenders/genders.c (genders_testattr): Fix bug where
	incorrect attribute copied into buffer.

	* tagged genders-1-3-0-pre3

2004-02-02  Albert Chu  <chu11@llnl.gov>

	* src/libgenders/genders.c: Variety of fixes.

2004-02-01  Albert Chu  <chu11@llnl.gov>

	* src/libgenders/genders.c: Globally added support for %n
	substitution.

	* man/libgenders.3: Updated with hostlist range info.

	* src/Genders/Genders.pm: Added more notes to Genders::getattrval.

2004-01-30  Albert Chu  <chu11@llnl.gov>

	* src/Libgenders/Makefile.am: Support hostlist code.
	
2004-01-27  Albert Chu  <chu11@llnl.gov>

	* src/libgenders/genders.c: Cleaned up code significantly.

	* src/libgenders/hostlist.h, src/libgenders.c: New files
	
2004-01-26  Albert Chu  <chu11@llnl.gov>

	* src/libgenders/genders.c: Fixed numerous bugs to support
	hostlist format.
	
2004-01-22  Albert Chu  <chu11@llnl.gov>

	* src/libgenders/genders.h.in, src/libgenders/genders.c: Initial
	re-programming to support hostlist formatting in genders database.

2004-01-15  Albert Chu  <chu11@llnl.gov>

	* src/libgenders/genders.c (_readline): Fix corner case.

	* src/libgenders/genders.c (_parse_line, genders_parse): Added
	support for additional corner case checks: non-shortened
	hostnames, duplicate attributes, and duplicate nodenames.

	* src/libgenders/genders.c: All list_create and
	list_iterator_create errors are now OUTMEM errors.
	
2004-01-14  Albert Chu  <chu11@llnl.gov>

	* src/nodeattr/nodeattr.c, src/libgenders/genders.c: Modify code
	style to fit GNU coding standards more closely.

2003-12-31  Albert Chu  <chu11@llnl.gov>

	* src/libgenders/Makefile.am, src/Genders/Genders.pm: Began
	consistent library versioning.
	
2003-12-30  Albert Chu  <chu11@llnl.gov>

	Updated all files with appropriate copyright header.
	
2003-11-07  Albert Chu  <chu11@llnl.gov>

	* src/nodeattr/Makefile.am: Added dependency check.

	* src/Libgenders/Makefile.am, src/Genders/Makefile.am: Added
	cleanup bug fix.
	
2003-11-06  Albert Chu  <chu11@llnl.gov>

	* src/libgenders/genders.c (_parse_line): Fixed some parsing code
	that was incorrect, but never hit a corner case due to the
	combination of some other code.
	
2003-11-03  Albert Chu  <chu11@llnl.gov>

	* man/genders_list.3: Added note about genders databases without
	any attributes.

	* man/genders_getattr.3, man/genders_testattr.3: Added additional
	note under GENDERS_ERR_NOTFOUND error.

	* tagged genders-1-3-0-pre2

2003-11-02  Albert Chu  <chu11@llnl.gov>

	* src/libgenders/list.h, src/libgenders/list.c,
	src/libgenders/fd.h, src/libgenders/fd.c: New files.

	* src/libgenders/genders.c: Re-written to use file descriptor and
	list library code.  Re-ordered error code return priority in many
	functions.

	* src/libgenders/genders.c (genders_load_data): Added corner case
	fix for genders databases with no nodes listed.

	* src/libgenders/Makefile.am: Incorporated new fd and list code.

	* src/nodeattr/nodeattr.c: Removed all code surrounded by "#if 0"
	and "#endif".

	* configure.ac: Replaced --with-xs-prefix and
	--with-genders-pm-prefix options with --with-perl-install-prefix
	option.

	* src/Libgenders/Makefile.am, src/Genders/Makefile.am: Modified
	for above change in configure.ac.

	* src/libgenders/genders_example.c: Cleaned up code.
	
2003-09-26  Albert Chu  <chu11@llnl.gov>

	* src/libgenders/genders.c (_insert_attrval_listnode): Fix bug
	that parsed database incorrectly.

	* tagged genders-1-3-0-pre1
	
2003-09-23  Albert Chu  <chu11@llnl.gov>

	* src/libgenders/genders.c (genders_parse): Fixed one remaining
	mistake maximum length handling code.

	* man/genders_getnodes.3: Fixed typo, cosnt -> const.

2003-09-22  Albert Chu  <chu11@llnl.gov>

	* src/libgenders/genders.c (genders_parse): Fixed logic error with
	output for length of line exceeding maximum length.

2003-09-20  Albert Chu  <chu11@llnl.gov>

	Enhanced performance of genders database input based on profile
	analysis.

	* src/libgenders/genders.c (_getline): Removed function.

	* src/libgenders/genders.c (_readline): Function no longer creates
	a buffer for the genders database line.  Takes a buffer as a
	parameter.  Returns GENDERS_ERR_OVERFLOW on buffer overflow.  

	* src/libgenders/genders.c (genders_load_data, genders_parse):
	Functions modified to use _readline instead of _getline.

	* src/libgenders/genders.c (genders_parse): Added message output
	informing user that a line in the genders file is too long.

	* man/genders_load_data.3, man/genders_parse.3: Added information
	regarding new GENDERS_ERR_OVERFLOW error that can be returned.

	* src/libgenders/genders.c (_insert_attr_listnode,
	genders_getnodes): Minor code cleanup fix.
	
2003-09-19  Albert Chu  <chu11@llnl.gov>

	* src/libgenders/genders.c (_parse_line): Added code to remove
	trailing white space on each line of the genders database.

	* src/libgenders/genders.c (_parse_line): Fixed a segfault corner
	case for nodes that do not have any attributes.

2003-09-11  Albert Chu  <chu11@llnl.gov>

	Modified build files

	* configure.ac: 
	Added output of genders.spec.
	Added call to AC_META.

	* genders.spec: Removed file.

	* genders.spec.in: New file, which replaces genders.spec.

	* config/ac_meta.m4: New file.

	* Removed all Makefile.in files and config files that will be
	generatd by bootstrap from the repository.

2003-08-18  Albert Chu  <chu11@llnl.gov>

	* man/: Replaced "Release 1.2" with "August 2003" in all manpages,
	to stay consistent with other package's manpages.

2003-08-15  Albert Chu  <chu11@llnl.gov>

	* src/Genders/Genders.pm: Remove automatic exports.

	* src/Libgenders/Libgenders.xs (genders_set_errnum): Added this
	undocumented function.

2003-08-13  Albert Chu  <chu11@llnl.gov>

	* src/Libgenders/MANFIEST: Remove pointless files from file list.

	* src/Libgenders/README: Removed File.

2003-08-12  Albert Chu  <chu11@llnl.gov>

	* genders.sample: Added "all" and "cluster=test" to each node in
	the sample genders database.

2003-08-04  Albert Chu  <chu11@llnl.gov>

	* src/nodeattr/nodeattr.c: Removed -r and -C options. 

	* man/nodeattr.1: Remove references to -r and -C options.

	* ChangeLog: Rewritten to conform to GNU standards.
	
	* Tagged genders-1-2-1

2003-07-15  Albert Chu  <chu11@llnl.gov>

	* Tagged genders-1-2-0-pre0

2003-05-15  Albert Chu  <chu11@llnl.gov>

	* src/libgenders/genders.c: Code cleaned up.
 
	* src/libgenders/genders.c (genders_testnode): Renamed to
	genders_isnode.

	* src/libgenders/genders.c (genders_isattr, genders_isattrval):
	New Functions.

	* src/libgenders/genders.c (genders_load_data): Removed memory leak.

	* src/nodeattr/nodeattr.c: Added warning message about future
	removal of -C option.

	* src/Libgenders/Libgenders.pm: Added perldoc manpage.
	
	* src/Libgenders/Libgenders.xs: Added accessor functions for
	genders error codes and constants.
	
	* src/Libgenders/Libgenders.xs: Rewritten to be an Object-Oriented
	API.
	
	* src/Genders/Genders.pm: New File.
	
	* man/genders_testnode.3: Removed

	* man/genders_isnode.3, man/genders_isattr.3,
	man/genders_isattrval.3: New Files.

	* dist subpackage: Removed. 

	* Tagged genders-1-1-10pre.
	
2003-04-24  Albert Chu  <chu11@llnl.gov>

	* src/libgenders/genders.c: Rewritten.

	* src/libgenders/genders.c (genders_open): Renamed to
	genders_load_data.
	
	* src/libgenders/genders.h.in: 
	Renamed GENDERS_ERR_NOTOPEN to GENDERS_ERR_NOTLOADED.  
	Renamed GENDERS_ERR_NOTCLOSED to GENDERS_ERR_ISLOADED.  
	Added GENDERS_ERR_NULLHANDLE and GENDERS_ERR_ERRNUMRANGE error codes.
	Removed GENDERS_ALTNAME_ATTRIBUTE, GENDERS_ALL_ATTRIBUTE, and
	GENDERS_CLUSTER_ATTRIBUTE.

	* src/libgenders/genders.c: Return appropriate new error codes,
	GENDERS_ERR_NOTCLOSED, GENDERS_ERR_ISLOADED, and
	GENDERS_ERR_NULLHANDLE.
	
	* src/libgenders/genders.c (genders_errnum, genders_strerror):
	Handle new error codes GENDERS_ERR_NULLHANDLE and
	GENDERS_ERR_ERRNUMRANGE.
	
	* src/libgenders/genders.c: Removed parse checks for "all" and
	"cluster" attributes in genders file.

	* genders.sample: Removed "cluster" and "all" attributes from sample.
	
	* src/libgenders/genders.c (genders_close, genders_elapsedtime): 
	Removed.
	
	* man/genders_open.3: Removed

	* man/genders_load_data.3: Added

	* Manpages updated to reflect new error codes.

	* Organization of project files reworked. 

	* Created compat and dist subpackages.
	
	* Tagged genders-1-1-9.
		
2003-04-14  Albert Chu  <chu11@llnl.gov>

	* Libgenders.xs (string_constant): Uses SV * instead of char *.
	
	* genders.spec: Added proper prefix to configuration so
	libgenders.la is built correctly.
	
	* Tagged genders-1-1-8.

2003-04-09  Albert Chu  <chu11@llnl.gov>

	* Added Libgenders Perl Extension library.
	
	* gendlib.pl: Updated to use Libgenders perl extension.
	
	* dist2.1: Removed reference to "/etc/cluster".
	
	* Tagged genders-1-1-7.

2003-04-01  Albert Chu  <chu11@llnl.gov>

	* genders.c (genders_open): Added parse checks for "cluster" and
	"all" attributes.
	
	* genders.c (genders_parse): New API Function.

	* genders.h (genders_parse): New API Function.

	* genders_parse.3: New File.
	
	* nodeattr.c: Added --check (-k) option.
	
	* genders.c: Cleaned up code.
	
	* genders.sample: Added "cluster" and "all" to sample.
	
	* Tagged genders-1-1-6.
	
2003-04-01  Jim Garlick  <garlick@llnl.gov>

	* nodeattr.c: Fixed -r option to return primary hostname when
	  altname lookup fails.
	
	* Tagged genders-1-1-5.

2003-03-31  Albert Chu  <chu11@llnl.gov>

	* genders.c: Fixed magic numbers error.

	* nodeattr.c: nodeattr.c binary installed instead of nodeattr perl
	script.

	* gendlib.pl: Removed dependence on /etc/clusters.

	* dist2: Removed dependence on /etc/clusters.

	* gendlib.3, dist2.1: Updated with above changes.
	
	* Tagged genders-1-1-4

2003-03-12  Albert Chu  <chu11@llnl.gov>

	* genders.h: 
	Moved unnecessary #include and #defines to genders.c.
	Added GENDERS_ERR_NULLPTR error code.
	
	* genders.c: 
	Added magic numbers to genders context.
	Fixed corner case errors based on test suite results.
	
	* genders.c (genders_testattr): Added buffer length parameter.

	* genders.c (genders_list_clear): Added corner case check.
	
	* genders.c (genders_getmaxnodenamelen): Renamed to genders_getmaxnodelen.

	* genders.c (genders_testnode, genders_errormsg): New Functions.

	* genders_testnode.3, genders_handle_destroy.3, genders_errormsg.3:
	New Files.

	* genders_testattr.3: Modified for API change.
	
	* genders_errors.3: Updated to include genders_errormsg.

        * Tagged genders-1-1-3.

2003-03-07  Albert Chu  <chu11@llnl.gov>

	* Libgenders manpages added.

	* genders.c (genders_errormsg): New Function.

	* Tagged genders-1-1-2.

2003-02-19  Albert Chu  <chu11@llnl.gov>

        * genders.h: Fixed comments.

2003-02-10  Albert Chu  <chu11@llnl.gov>

	* genders.c, genders.h, nodeattr.c: New Files.

	* META, genders.spec, Makefile.am: Updated for new additions.
	
	* Tagged genders-1-1-1.

2003-01-21  Jim Garlick  <garlick@llnl.gov>

	* Tag genders-1-0-2

2002-12-08  Jim Garlick  <garlick@llnl.gov>

	* inst.c: Ran through "indent --no-tabs -kr *.[ch]". 

	* DISCLAIMER: Updated in accordance to release instructions.

	* Added headers to source files in accordance to release instructions.

	* Added vi footers in all scripts and source files.
	
        * Make-rpm.mk: Updated to latest project.
	
        * Tagged genders-1-0-1chaos.

2002-09-13  Jim Garlick  <garlick@llnl.gov>

	* ChangeLog: Reformmated.

	* Changed ksh to sh in shell scripts

	* Make-rpm.mk: Updated to latest.

	* Tagged genders-0-2-7chaos.

2002-05-31  Jim Garlick  <garlick@llnl.gov>

	* dist2: Removed -r optoin. Added -i option.

	* dist2.1: Updated to reflect changes.
	
	* Tagged genders-0-2-6chaos.

2002-05-24  Jim Garlick  <garlick@llnl.gov>
	* Added -r option to nodeattr in dist_all.
	* Tagged genders-0-2-5chaos.

2002-04-24  Jim Garlick  <garlick@llnl.gov>
	
	* TUTORIAL: Cleaned up.
	
	* genders.spec: Removed updatefstab and updateservice.
	
	* Tagged genders-0-2-4chaos.

2002-04-23  Jim Garlick  <garlick@llnl.gov>
	
	* TUTORIAL: New File.

	* Updated to Chris Dunlap's latest RPM rules.

	* Removed updatefstab and updateservice scripts per Robin
	Goldstone's request.

	* Sent to Rand at LANL.
	
	* Tagged genders-0-2-3chaos.
	

2001-07-14  Jim Garlick  <garlick@llnl.gov>

	* Updated to Chris Dunlap's latest RPM rules.

	* updatefstab, updateservice: New Files.

	* Tagged genders-0-2-2.

2001-07-14  Jim Garlick  <garlick@llnl.gov>

	* Makefile: Added RPM target.

	* Tagged genders-0-2.

2001-07-14  Jim Garlick  <garlick@llnl.gov>

	* genders.spec, DISCLAIMER: New Files.

	* dist_passwd: Removed File.

	* Tagged genders-0-1.

XXXX-XX-XX  Jim Garlick  <garlick@llnl.gov>

	Following are early notes on modifications and additions.
	
	* Path changes: 
	  /admin/bin/per	-> /usr/bin/perl
	  /admin/etc/genders 	-> /etc/genders
	  /admin/etc/clusters	-> /etc/clusters
	  /admin/lib/gendlib.pl	-> /usr/lib/genders/gendlib.pl
	  /admin/scripts/dist2	-> /usr/bin/dist2
	  /var/dist/bootstrap	-> /usr/bin/dist_bootstrap

	* Now that we have an RPM, dist_bootstrap only has to copy out
	  /etc/genders and /etc/clusters.

	* Makefile only attempts to build inst.

	* Remove "require 5.003" lines; instead require perl in spec file.

	* Removed herolib.pl stuff temporarily.  It needs to be merged back in.

	* If not PSSP, assume /usr/bin/rdist is USC rdist, and default rsh 
	  is OK.

	* Only include sdrlib.pl in gendlib.pl.  Genders::to_altnames and
	  Genders::to_gendnames now provide conversion between genders 
	  hostnames and alternate hostnames.  On the SP, this is accomplished 
	  using the sdrlib functions which access the initial_hostname and 
	  reliable_hostname SDR attributes.  On other systems, "altname" 
	  genders attribute holds the alternate hostname (gendlib.pl, dist2).

	* Added "-c <cluster>" option.  This tells dist2 to use 
	  /admin/etc/genders.<cluster> instead of the default.  Handy for 
	  rdisting to a foreign cluster, e.g. one that is behind a bastion 
	  host that can mount /var/dist (but inside can't mount it) (dist2).

	* Added "-o <options>" option.  List of options are passed
	  through to the real rdist, e.g. "dist2 -o verify" (dist2).

	* Don't look for /var/dist/VAR_DIST_IS_MOUNTED if "-f Distfile" option
	  specified (dist2).

	* If -n option specified, implicitly set -v (dist2).

	* GNU fileutils 4.0p include install program with -C option.
	  This is the main reason for having the 'inst' utility, therefore it
	  should now be considered deprecated.  Update your rdist Makefiles
	  to use GNU install -C.

	* Removed jmd stuff (hostlist.pl).
